part of mason_dart;

class AssetBundle{

  /// Imports a .gltf or .glb file
  static Future<AssetBundle> import(String url, {bool eager = false}) async {
    var client = new io.HttpClient();

    io.HttpResponse response = await client.get(url);

    if(response.headers.contentType.mimeType != "model/gltf+json"){
      throw new Exception("Invalid file type.");
    }

    var allBytes = new List<int>();
    await response.body.readBytes().listen((data){
      allBytes.addAll(data);
    });
    String s = new String.fromCharCodes(allBytes);
    var parsed = JSON.decode(s);
    var defaultSceneIndex = parsed["scene"];
    var scenes = parsed["scenes"];
    print(defaultSceneIndex);
    print(parsed['buffers']);

    for(var buffer in parsed['buffers']){
      var uri = buffer['uri'];
      if(uri == null){
        /// There buffer is embedded in file(glb)
      } else if(uri is String && uri.startsWith("data:")){
        //BASE64 encoded data.
      } else if(uri is String) {
        client.get(uri);
      }

      var byteLength = buffer['byteLength'];
      var name = buffer['name'];
      //Need to get the buffer.
    }

    return new Future.value(new AssetBundle._());
  }

  Scene defaultScene;

  List<Scene> scenes;


  List<BufferData> buffers;

  AssetBundle._(){

  }

}

class BufferData{
  String uri;
  String name;
  int byteLength;
  Future<Uint8List> buffer;

  BufferData({String uri, String name, int byteLength, Uint8List buffer}){

  }
}

class Scene{
  String name;
  List<Node> children;
}

class Node{
  String name;
  Transform transform;
  List<Node> children;
  Mesh mesh;
}

class MeshData{
  String name;
  MeshAttributes attributes;
  Uint8List indices;
  Uint8List vertexData;
}

