part of dart_mason;


/// Decode a JPEG image in bytes to an [Texture] object
class JPEGDecoder extends Converter<Uint8List, Texture>{

  _JPEGDecoder _decoder = new _JPEGDecoder();

  @override
  Texture convert(Uint8List input) {
    return _decoder.decode(input);
  }

  Future<Texture> convertAsync(Uint8List input) {
    return _decoder.decodeAsync(input);
  }
}

class _JPEGDecoder extends NativeFieldWrapperClass2{
  SendPort sendPort;

  _JPEGDecoder(){
    _constructor();
  }

  _constructor() native "JPEGDecoder_constructor";

  Texture decode(Uint8List input) native "JPEGDecoder_decode";

  Future<Texture> decodeAsync(Uint8List input){
    return _MasonService._dispatch(_JPEG_DECODE, [input]).then((response){
      int width = response[0];
      int height = response[1];
      int channels = response[2];
      Uint8List pixel_data = response[3];
      //Use response to create Texture.
      TextureFormat format;
      switch(channels){
        case 1:
          format = TextureFormat.RED;
          break;
        case 2:
          format = TextureFormat.RG;
          break;
        case 3:
          format = TextureFormat.RGB;
          break;
        case 4:
          format = TextureFormat.RGBA;
          break;
      }
      var t = new Texture(width, height, format: format);
      t.SetPixelData(pixel_data);
      return t;
    });

  }
}


/// Decode a PNG image in bytes to an [Texture] object
//class PNGDecoder extends Converter<Uint8List, Texture>{
//
//  _PNGDecoder _decoder = new _PNGDecoder();
//
//  @override
//  Texture convert(Uint8List input) {
//    return _decoder.decode(input);
//  }
//
//  Future<Texture> convertAsync(Uint8List input) {
//    return _decoder.decodeAsync(input);
//  }
//}

//class _PNGDecoder extends NativeFieldWrapperClass2{
//  SendPort sendPort;
//
//  _PNGDecoder(){
//    _constructor();
//  }
//
//  _constructor() native "PNGDecoder_constructor";
//
//  Texture decode(Uint8List input) native "PNGDecoder_decode";
//
//  Future<Texture> decodeAsync(Uint8List input){
//    return _MasonService._dispatch(_PNG_DECODE, [input]).then((response){
//      int width = response[0];
//      int height = response[1];
//      Uint8List pixel_data = response[2];
//      //Use response to create Texture.
//      var t = new Texture(width, height, format: TextureFormat.RGB );
//      t.SetPixelData(pixel_data);
//      return t;
//    });
//
//  }
//}
