part of dart_mason;

class _Light{

}

class _DirectionalLight {
  Vector3 direction;
  Vector3 color = new Vector3.all(1.0);

  double _intensity;

  /// Controls the brightness of the light
  double get intensity => _intensity;

  /// Controls the brightness of the light
  set intensity(double value) {
    if (value <= 1.0 && value >= 0.0) {
      _intensity = value;
    } else {
      throw "Intensity must be between 0.0 and 1.0";
    }
  }
}

class PointLight extends _Light {
  Vector3 position = new Vector3.zero();
  Vector3 color = new Vector3.all(100.0);

  PointLight({Vector3 position, Vector3 color}){
    if(position != null){
      this.position = position;
    }
    if(color != null){
      this.color = color;
    }
  }


  /// Controls how far the light is emitted -
  /// attenuation radius
//  double range = 10.0;

//  double _intensity;
//
//  /// Controls the brightness of the light
//  double get intensity => _intensity;
//
//  /// Controls the brightness of the light
//  set intensity(double value) {
//    if (value <= 1.0 && value >= 0.0) {
//      _intensity = value;
//    } else {
//      throw "Intensity must be between 0.0 and 1.0";
//    }
//  }
}

class _SpotLight {
  Vector3 position = new Vector3.zero();
  Quaternion rotation = new Quaternion.identity();

  /// Controls how far the light is emitted -
  /// attenuation radius
  double range = 10.0;

  /// Controls the angle of the spot light.
  double _spotAngle = 10.0;
  double get spotAngle => _spotAngle;
  set spotAngle(double value) {
    if (value >= 1.0 && value <= 180.0) {
      _intensity = value;
    } else {
      throw "Intensity must be between 0.0 and 1.0";
    }
  }

  /// Controls the brightness of the light
  double get intensity => _intensity;

  /// Controls the brightness of the light
  set intensity(double value) {
    if (value <= 1.0 && value >= 0.0) {
      _intensity = value;
    } else {
      throw "Intensity must be between 0.0 and 1.0";
    }
  }

  double _intensity;
}
