part of dart_mason;

class ModelLoader extends NativeFieldWrapperClass2 {
  Completer<Component> _completer = new Completer();
  final String _url;

  static Set<ModelLoader> loaders_ = new Set();

  /// We tried to use this but it caused multi threading problems.
  static Future<Component> __fromUrl1(String url) async {
    var loader = new ModelLoader._(url);
    loaders_.add(loader);
    loader._Start(url);
    loader.future.whenComplete(() {
      loaders_.remove(loader);
    });
    return loader.future;
  }

  static Future<Component> fromUrl(String url, {Material material}) async {
    material ??= Material.DEFAULT;
    var client = new io.HttpClient();
    var response = await client.get(url);
    var bytes = response.body.readBytes();
    List<List<int>> allBytesList = [];
    var totalSize = 0;
    var completer = new Completer<Component>();
    bytes.listen((a) {
      totalSize += a.length;
      allBytesList.add(a);
    }).onDone(() {
      Int32List allBytes = new Int32List(totalSize);
      _InternalBuffer buffer = new _InternalBuffer();
      buffer.initialize(totalSize);
      var start = 0;
      for (var l in allBytesList) {
        var end = start + l.length;
        buffer.loadList(start, l);
        start = end;
      }
      var loader = new ModelLoader._(url);
      completer.complete(loader._fromTypedList(buffer.toList(), url, material));
      return;
    });
    return completer.future;
  }

  Future<Component> get future => _completer.future;

  ModelLoader._(this._url) {
    _constructor();
  }

  _constructor()
      native "ModelLoader_constructor"; // ignore: native_function_body_in_non_sdk_code

  _Start(String url) {
    _StartNative(url, _completer);
  }

  _StartNative(String url, Completer completer) native "ModelLoader_Start";

  _fromUrl(String url) {
    var completer = new Completer<Component>();
    _loadModel(url, completer);
    return completer.future;
  }

  _fromTypedList(Uint8List data, String url, Material material) native "ModelLoader_FromList";

  _loadModel(String url, Completer<Component> completer)
      native "ModelLoader_loadModel"; // ignore: native_function_body_in_non_sdk_code

  String toString(){
    return "ModelLoader ${_url}";
  }

}

class _FutureChecker {
  final Future future;
  bool get isComplete => _isComplete;
  bool _isComplete = false;
  dynamic get value => _value;
  dynamic _value = null;

  _FutureChecker(this.future) {
    this.future.then((result) {
      _value = result;
    });
    this.future.whenComplete(() {
      _isComplete = true;
    });
  }
}

/// Used within C++ code to do a synchronous HTTP.
_FutureChecker _SyncHttpHelper(String url) {
  var completer = new Completer<List<int>>();
  Timer.run((){
    var client = new io.HttpClient();
    var futureResponse = client.get(url);
    futureResponse.whenComplete(() {});
    var listFuture = futureResponse.then((response) async {
      List<int> data = [];
      await for (var list in response.body.readBytes()) {
        data.addAll(list);
      }
      completer.complete(data);
    });
  });
  var checker = new _FutureChecker(completer.future);
  return checker;
}
