part of dart_mason;

class Transform {
  Vector3 _position;
  Quaternion _rotation;
  Vector3 _scale;

  Function _onChange = () {};

  Transform({
    position,
    scale,
    rotation,
  }) {
    position ??= new Vector3.zero();
    _position = position;
    rotation ??= new Quaternion.identity();
    _rotation = rotation;
    scale ??= new Vector3(1.0, 1.0, 1.0);
    _scale = scale;
  }

  Transform._inner(Vector3 position, Quaternion rotation){
    _position = position;
    _rotation = rotation;
    _scale =  new Vector3(1.0, 1.0, 1.0);

  }

  Vector3 get position => _position;

  set position(Vector3 value) {
    _position = value;
    _onChange();
  }

  Quaternion get rotation => _rotation;

  set rotation(Quaternion value) {
    _rotation = value;
    _onChange();
  }

  Vector3 get scale => _scale;

  set scale(Vector3 value) {
    _scale = value;
    _onChange();
  }

  Matrix4 get matrix {
    return new Matrix4.compose(_position, _rotation, _scale);
  }

  Transform _parent;
  set parent(Transform value) {
    _parent = value;
  }

//   Vector3 globalPosition;
//   Vector3 globalRotation;
//   Vector3 globalScale;
}
